--	Ce Mod est un petit outil qui affiche en haut à droite le prix le plus élevé des produits.
--	Lorsqu'il y a des produit en forte demande, les prix correspondant clignote.
--	La combinaison des touches Alt et F2 permet d'activer ou désactiver l'affichage.

-- V1.62
-- Correction de la warning sur le fichier dds
-- Correction du problème de clignotement des prix
-- Correction de l'affichage du prix des produits porc et boeuf

-- V1.61
-- Ajout de l'affichage de la quantité de l'ensilage.

-- V1.60
-- Correction de la fréquence de clignotement des produits en forte demande.
-- Ajout de l'affichage de la quantité en stock des produits

-- V1.50
-- Optimisation du code source
-- Gestion de la position des informations de manière proportionnelle à la résolution graphique

-- V1.40
-- Amélioration du graphisme.
-- Déplacement de l'affichage vers le bas si le Mod AnimalHUD est présent.

-- V1.33
-- Gestion de l'affichage pour les résolution écran inférieures à 1920x1080

-- V1.32
-- Ajout du traitement particulier du produit "cochon" de certaines Map

-- V1.31
-- Correction de l'erreur d'affichage des libellés du nom des produits et des lieux

-- V1.30
-- Ajout du nom de l'endroit ou le prix est le meilleur

-- V1.20
-- Ajout des copeaux de bois et de l'ensilage

-- V1.10
-- Ajout de la combinaison des touches Alt et F2 pour activer ou désactiver l'affichage

-- V1.00
-- Première version



-- This Mod is a small tool that displays at the top right the higher product prices.
-- When there is a product in high demand, the corresponding prize flashes.
-- The combination of Alt and F2 keys to enable or disable the display.

-- V1.62
-- Fixed the warning on the dds file
-- Fixed price flickering problem
-- Fixed the display of the prices pork and beef products

-- V161
-- Uploading the display of the amount of silage.

-- V1.60
-- Fixed the flashing frequency high-demand products.
-- Added display of the quantity of products in stock

-- V1.50
-- Optimization of the source code
-- Management of the position information proportional to the graphic resolution

-- V1.40
-- Improved graphics.
-- Moving the display down if the Mod AnimalHUD is present.

-- V1.33
-- Managing the display for the lower screen resolution to 1920x1080

-- V1.32
-- Adding the special treatment of the product "pig" of some Map

-- V1.31
-- Fixed display error labels with the names of products and places

-- V1.30
-- Adding the name of the place where the price is the best

-- V1.20
-- Adding wood chips and silage

-- V1.10
-- Adding the combination of Alt and F2 keys to toggle the display.

-- V1.00
-- First Version

-- This is my Mod, I realized myself.
	
MinMax = {};
MinMax.timerPrix = { 
	id = nil,
	intervaleTimer = 1000
	};
MinMax.timerClignotant = {
	id = nil,
	intervaleTimer = 800
	};

MinMax.multiplicateurDeDifficulte = 0;
MinMax.actif = true;
MinMax.dossierMod = g_currentModDirectory;
MinMax.grosseDemandeVisible = nil;

MinMax.taillePolice = 0.014
MinMax.yNomType = 0.850
MinMax.largeurNomMax = 0;
MinMax.largeurPrixMax = 0;
MinMax.largeurLieuMax = 0;
MinMax.largeurStockMax = 0;

MinMax.produit = {}
function MinMax.produit.new()
	local self = {};
	
	self.prix = 0;
	self.lieu = "";
	self.enGrosseDemande = false;
	self.indexeDesc = nil;
	self.stock = 0;
	self.nomTraduit = "";
	return self;
end;


	
MinMax.produits = {};
MinMax.produitsClasses = {};

MinMax.etatsBunkerSilo = { 
	"Fill",
	"Close",
	"Drain"
	}



MinMax.colors = {
		white =         { 255/255, 255/255, 255/255, 1.00 };
		whiteInactive = { 255/255, 255/255, 255/255, 0.75 };
		whiteDisabled = { 255/255, 255/255, 255/255, 0.15 };
		hover =         {   4/255,  98/255, 180/255, 1.00 }; 
		activeGreen =   {  43/255, 205/255,  10/255, 1.00 }; 
		activeRed =     { 153/255,  22/255,  19/255, 1.00 }; 
		closeRed =      { 116/255,   0/255,   0/255, 1.00 }; 
		warningRed =    { 222/255,   2/255,   3/255, 1.00 }; 
		shadow =        {   4/255,   4/255,   4/255, 1.00 }; 
		textDark =      {   1/255,   1/255,   1/255, 1.00 }; 
	};

	
-------------------------------------------------------------
--	MinMax:loadMap(name)
-------------------------------------------------------------	
function MinMax:loadMap(name)
	MinMax.timerPrix.id = addTimer(MinMax.timerPrix.intervaleTimer, "MinMax.timerPrix");
	MinMax.timerClignotant.id = addTimer(MinMax.timerClignotant.intervale, "MinMax.timerClignotant");
	
	self.ovid = createImageOverlay(Utils.getFilename("MinMax.png", MinMax.dossierMod));
	
	MinMax.multiplicateurDeDifficulte = math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1);
end;


-------------------------------------------------------------
--	MinMax:deleteMap()
-------------------------------------------------------------
function MinMax:deleteMap()
	removeTimer(MinMax.timerPrix.id)
	removeTimer(MinMax.timerClignotant.id)
	MinMax.produits = {};
	MinMax.produitsClasses = {};
end;


-------------------------------------------------------------
--	MinMax:mouseEvent(posX, posY, isDown, isUp, button)
-------------------------------------------------------------
function MinMax:mouseEvent(posX, posY, isDown, isUp, button)
end;


-------------------------------------------------------------
--	MinMax:keyEvent(unicode, sym, modifier, isDown)
-------------------------------------------------------------
function MinMax:keyEvent(unicode, sym, modifier, isDown)

	if ( isDown) then
		if sym == 283 then
			if bitAND(modifier,4095) == 256 then
				if (MinMax.actif) then
					MinMax.actif = false;
				else
					MinMax.actif = true;
				end;
			end;
		end;
	end;
end;

-------------------------------------------------------------
--	MinMax:update(dt)
-------------------------------------------------------------
function MinMax:update(dt)
end;

-------------------------------------------------------------
--	MinMax:draw()
-------------------------------------------------------------
function MinMax:draw()
		
	
	if ( MinMax.actif) then

		setTextBold(false);
		setTextColor(unpack(self.colors['white']))
		
		local y = MinMax.yNomType
		
		if ( AnimalHUD ~= nil) then
			y = y - 0.250
		end;
		local nbProduits = table.getn( MinMax.produitsClasses)
		local hauteurHud =  MinMax.taillePolice * nbProduits + 0.010
		local largeurHud = 0.005 + MinMax.largeurNomMax + 0.005 + MinMax.largeurPrixMax + 0.005 + MinMax.largeurLieuMax + 0.005
		local largeurHudStock = 0.005 + MinMax.largeurNomMax + 0.005 + MinMax.largeurStockMax + 0.005

		renderOverlay( self.ovid, 1 - largeurHud, y - hauteurHud + MinMax.taillePolice + 0.0025, largeurHud, hauteurHud  )
		renderOverlay( self.ovid, 1 - largeurHudStock, y - 2 * hauteurHud + MinMax.taillePolice + 0.0025, largeurHudStock, hauteurHud  )
		
		for i, nomTraduit in pairs(MinMax.produitsClasses) do
			local produitCourant = produitParNomTraduit( nomTraduit)
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText( 1 - ( MinMax.largeurNomMax + 0.005 + MinMax.largeurPrixMax + 0.005 + MinMax.largeurLieuMax + 0.005), y, MinMax.taillePolice, nomTraduit);
			renderText( 1 - ( MinMax.largeurNomMax + 0.005 + MinMax.largeurStockMax + 0.005), y - hauteurHud , MinMax.taillePolice, nomTraduit);
			
			setTextAlignment(RenderText.ALIGN_RIGHT);			
			
			renderText( 1 - 0.005, y - hauteurHud , MinMax.taillePolice, string.format("%s", produitCourant.stock));
			local prix = string.format("%4s", produitCourant.prix);
			if( produitCourant.enGrosseDemande ) then
				if (MinMax.grosseDemandeVisible) then
					renderText( 1 - ( 0.005 + MinMax.largeurLieuMax + 0.005), y, MinMax.taillePolice, prix)
				end;
			else
				renderText(1- ( 0.005 + MinMax.largeurLieuMax + 0.005), y, MinMax.taillePolice, prix)
			end;
			
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText( 1 - ( MinMax.largeurLieuMax + 0.005), y, MinMax.taillePolice,  produitCourant.lieu );
			y = y - MinMax.taillePolice
		end;
	end;
end;

-------------------------------------------------------------
--	timerPrix()
-------------------------------------------------------------
function timerPrix()
	prix()
	
	setTimerTime(MinMax.timerPrix.id, MinMax.timerPrix.intervaleTimer);
	
	return true;
end;

-------------------------------------------------------------
--	prix()
-------------------------------------------------------------
function prix()

	if ( MinMax.actif) then
		if ( table.getn( MinMax.produitsClasses) == 0) then

			for k,tipTrig in pairs(g_currentMission.tipTriggers) do
				local nomTrigger = g_i18n:getText(tipTrig.stationName)
				if ( string.sub( nomTrigger, 1, 7) ==  "Missing" and string.sub( nomTrigger, string.len( nomTrigger) - 3, string.len( nomTrigger)) == ".xml") then
					nomTrigger = tipTrig.stationName
				end;
				local largeurLieu = getTextWidth( MinMax.taillePolice, nomTrigger);
				if ( largeurLieu > MinMax.largeurLieuMax) then
					MinMax.largeurLieuMax = largeurLieu
				end;
				
				if ( tipTrig.stationName ~= "BunkerSilo" and tipTrig.stationName ~= "Station") then
			
					local fillTypes = getUserAttribute(tipTrig.triggerId, "fillTypes");
					if fillTypes == nil then
						fillTypes = getUserAttribute(tipTrig.triggerId, "fruitTypes");
					end
					
					local types = Utils.splitString(" ", fillTypes);
					for indexeType, nom in pairs(types) do
						local desc = Fillable.fillTypeNameToDesc[nom]
						if (desc ~=nil and MinMax.produits[nom] == nil)  then
							local produitCourant = MinMax.produit.new();
							produitCourant.indexeDesc = desc.index
							produitCourant.nomTraduit = desc.nameI18N
							MinMax.produits[nom] = produitCourant
							
							local largeurNom = getTextWidth( MinMax.taillePolice, produitCourant.nomTraduit);
							if ( largeurNom > MinMax.largeurNomMax) then
								MinMax.largeurNomMax = largeurNom
							end;
						end;
					end;
				end;
			end;
			
			MinMax.produitsClasses = {};
			
			for nomType, produit in pairs(MinMax.produits) do
				table.insert(MinMax.produitsClasses, produit.nomTraduit)
			end;
			table.sort( MinMax.produitsClasses)
		end;
		
		MinMax.produits["silage"].stock = 0
		
		for i, produitCourant in pairs(MinMax.produits) do
			produitCourant.prix = 0;
		end;
		for k,tipTrig in pairs(g_currentMission.tipTriggers) do
			
			if ( tipTrig.stationName ~= "Station") then

				local nomTrigger = g_i18n:getText(tipTrig.stationName)
				if ( string.sub( nomTrigger, 1, 7) ==  "Missing" and string.sub( nomTrigger, string.len( nomTrigger) - 3, string.len( nomTrigger)) == ".xml") then
					nomTrigger = tipTrig.stationName
				end;
				
				if ( tipTrig.stationName == "BunkerSilo") then
					if( tipTrig.bunkerSilo.state ~= nil) then
						local nomType = "silage"
						
						if ( MinMax.etatsBunkerSilo[tipTrig.bunkerSilo.state + 1] == "Drain" ) then
							
							MinMax.produits[nomType].stock = MinMax.produits[nomType].stock + math.ceil(tipTrig.bunkerSilo.fillLevel)
								
							local largeurStock = getTextWidth( MinMax.taillePolice, string.format("%u", MinMax.produits[nomType].stock));
							
							if ( largeurStock > MinMax.largeurStockMax) then
								MinMax.largeurStockMax = largeurStock
							end;
						end;
					end;
				else
				
					
					for nomType, produitCourant in pairs(MinMax.produits) do
					
						if ( tipTrig.priceMultipliers[produitCourant.indexeDesc] ~= nil) then
							local multiplicateurGrosseDemande = 1;
							local greatDemand = g_currentMission.economyManager:getCurrentGreatDemand(tipTrig.stationName, produitCourant.indexeDesc);
						   
							if greatDemand ~= nil then
								multiplicateurGrosseDemande = greatDemand.demandMultiplier;
								MinMax.produits[nomType].enGrosseDemande = true
							else
								MinMax.produits[nomType].enGrosseDemande = false
							end;
							
							local prix = MinMax.multiplicateurDeDifficulte * tipTrig.priceMultipliers[produitCourant.indexeDesc] * Fillable.fillTypeIndexToDesc[produitCourant.indexeDesc].pricePerLiter * multiplicateurGrosseDemande
							
							if ( nomType ~= "pig" and nomType ~= "beef") then
								prix = math.ceil( prix * 1000)
							end;
									
							if ( prix > MinMax.produits[nomType].prix ) then
								MinMax.produits[nomType].prix = prix
								MinMax.produits[nomType].lieu = nomTrigger
								
								local largeurPrix = getTextWidth( MinMax.taillePolice, string.format("%u", prix) )
								if (  largeurPrix > MinMax.largeurPrixMax) then
									MinMax.largeurPrixMax = largeurPrix
								end;
							end
											
							MinMax.produits[nomType].stock = math.ceil(g_currentMission:getSiloAmount( MinMax.produits[nomType].indexeDesc))
					
							local largeurStock = getTextWidth( MinMax.taillePolice, string.format("%u", MinMax.produits[nomType].stock));
							
							if ( largeurStock > MinMax.largeurStockMax) then
								MinMax.largeurStockMax = largeurStock
							end;
						end;
					end;
				end;
			end;
		end;
	end;
end;	


-------------------------------------------------------------
--	produitParNomTraduit( nomTraduit)
-------------------------------------------------------------
function produitParNomTraduit( nomTraduit)

	for nomType, produitCourant in pairs(MinMax.produits) do
		if ( produitCourant.nomTraduit == nomTraduit) then
			return produitCourant
		end;
	end;
end;

-------------------------------------------------------------
--	timerClignotant()
-------------------------------------------------------------
function timerClignotant()

	if ( MinMax.actif) then
		if ( MinMax.produitEnGrosseDemande ~= "") then
			if (MinMax.grosseDemandeVisible) then
				MinMax.grosseDemandeVisible = false
			else
				MinMax.grosseDemandeVisible = true
			end;
		else
			MinMax.grosseDemandeVisible = false
		end;
		
	end;
		
	setTimerTime(MinMax.timerClignotant.id, MinMax.timerClignotant.intervaleTimer);
	
	return true;
end;


addModEventListener(MinMax);

local modItem = ModsUtil.findModItemByModName(g_currentModName);

print(string.format("Script loaded: MinMax.lua (v%.2f)", modItem.version));


